#ifndef __OOL_H__
#define __OOL_H__

#include "xinclude.h"
#include "xheaders.h"
#include "XString.h"
#include "xdate.h"
#include "xtime.h"
#include "xexcept.h"


#ifdef INCL_OOL
   #define INCL_OOL_WIN
   #define INCL_OOL_FILE
   #define INCL_OOL_PROCESS
   #define INCL_OOL_MM
   #define INCL_OOL_JAVA
   #define INCL_OOL_DBASE
#endif

#ifdef INCL_OOL_WIN
   #include "XAtom.h"
   #include "xcosys.h"
   #include "xclipbrd.h"
   #include "xexit.h"
   #include "xcolor.h"
   #include "xcontcol.h"
   #include "xcontinf.h"
   #include "xcontobj.h"
   #include "xglfldlg.h"
   #include "xevent.h"
   #include "xcntrevn.h"
   #include "xfiledlg.h"
   #include "xgraphdv.h"
   #include "xgraphob.h"
   #include "xbox.h"
   #include "xpeak.h"
   #include "xlayer.h"
   #include "xline.h"
   #include "xmarker.h"
   #include "xhelp.h"
   #include "xmenuitm.h"
   #include "xcons.h"
   #include "xpoint.h"
   #include "xprocess.h"
   #include "xapp.h"
   #include "xrect.h"
   #include "xres.h"
   #include "xreslib.h"
   #include "xwindow.h"
   #include "xcontrol.h"
   #include "xbutton.h"
   #include "xsetbtn.h"
   #include "xcheckbx.h"
   #include "xradio.h"
   #include "xgraphbt.h"
   #include "xpushbtn.h"
   #include "xcircsld.h"
   #include "xcontain.h"
   #include "xentry.h"
   #include "xframe.h"
   #include "xlistbox.h"
   #include "xcombo.h"
   #include "xmle.h"
   #include "xscrlbar.h"
   #include "xslider.h"
   #include "xspinbtn.h"
   #include "xvaluset.h"
   #include "xfrmwnd.h"
   #include "xscrlwnd.h"
   #include "xmenu.h"
   #include "xmenubar.h"
   #include "xpopmenu.h"
   #include "xobjwnd.h"
   #include "xgroupbx.h"
   #include "xsbitmap.h"
   #include "xsframe.h"
   #include "xsicon.h"
   #include "xstext.h"
   #include "xuserwnd.h"
   #include "xfrmcnt.h"
   #include "xdragtra.h"
   #include "Xlayout.h"
   #include "xtoolbar.h"
   #include "xmsgbox.h"
   #include "xtext.h"
   #include "xhandler.h"
   #include "xdraghdl.h"
   #include "xdragevn.h"
   #include "xdragitm.h"
   #include "xmousevn.h"
   #include "xmoushdl.h"
   #include "xconthdl.h"
   #include "xcntevnt.h"
   #include "xkeybhdl.h"
   #include "xkeyevnt.h"
   #include "xcndrevn.h"
   #include "xwindrag.h"
   #include "xcnedevn.h"
   #include "xitmdevn.h"
   #include "xitmdhdl.h"
   #include "xbackhdl.h"
   #include "xbackevn.h"
   #include  "xstylhdl.h"
   #include "xbitmap.h"
   #include "xuserbtn.h"
   #include "xdefhdl.h"
   #include "xmlesear.h"
   #include "xxtmsgbx.h"
   #include "xcircle.h"
   #include "xarc.h"
   #include "xchart.h"
   #include "xpie.h"
   #include "xnotebk.h"
   #include "xbookpg.h"
   #include "xdde.h"
   #include "xtimer.h"
   #include "xbubble.h"
   #include "xicon.h"
   #include "xprofile.h"
   #include "xfontdlg.h"
   #include "xbar.h"
   #include "xrexx.h"
   #include "xprint.h"
   #include "xcountry.h"
   #include "xsize.h"
   #include "xrexxex.h"
   #include "xmodlg.h"
   #include "xmodal.h"
   #include "xnbevent.h"
   #include "xnbhdlr.h"
   #include "xmdiserv.h"
   #include "xmdicli.h"
   #include "xdentry.h"
   #include "xtentry.h"
   #include "xtraffic.h"
   #include "xled.h"
   #include "xcal.h"
   #include "xcursor.h"
   #include "xreswin.h"
   #include "xcwiz.h"
   #include "XWizard.h"
#endif

#ifdef INCL_OOL_FILE
   #include "xfile.h"
   #include "xfilefi.h"
   #include "xfileinf.h"
#endif

#ifdef INCL_OOL_PROCESS
   #include "xthread.h"
   #include "xsem.h"
   #include "xesem.h"
   #include "xmusem.h"
   #include "xsemex.h"
   #include "xpmthr.h"
   #include "xnpipe.h"
   #include "xcpipe.h"
   #include "xpipe.h"
   #include "xcrypt.h"
#endif

#ifdef INCL_OOL_MM
   #include "xmedia.h"
   #include "xsound.h"
   #include "xvideo.h"
   #include "xcd.h"
   #include "xpal.h"
   #include "xblitter.h"
   #include "xbltwnd.h"
#endif

#ifdef INCL_OOL_JAVA
   #include "xjavaenv.h"
   #include "xjavaapp.h"
#endif

#ifdef INCL_OOL_DBASE
   #include "xdbasefi.h"
   #include "xdbaseex.h"
   #include "xdbasere.h"
#endif

#endif