#include <ool.h>
#include "oolGlib.h"
#include "oolGres.rh"

#include XPushButton_i
#include XApplication_i
#include XCheckBox_i
#include XComboBox_i
#include XFrameWindow_i
#include XModalDialog_i
#include XNoteBook_i
#include XNoteBookPage_i
#include XRadioButton_i
#include XResource_i
#include XResourceLibrary_i
#include XSpinButton_i

class XBitmapFilterDialog: public XModalDialog {
   protected:
      XNoteBook*              notebook;
      XNoteBookPage*          page1;
      
   public:
      XBitmapFilterDialog (XWindow* o);
};

XBitmapFilterDialog :: XBitmapFilterDialog (XWindow* o):
   XModalDialog (IDR_FILTER_PARAMETERS_WARP4, o, TRUE) {

   XRect size1, size2;
   notebook = (XNoteBook*) GetWindow (IDC_NOTEBOOK);
   notebook->GetSize (&size1);
   GetWindow (DID_OK)->GetSize (&size2);
   notebook->SetMajorTabSize (size1.GetWidth () / 6, size2.GetHeight ());
cerr << "nb=" << (void*) notebook->GetHandle ();

   XString           tabText;
   XResourceLibrary* resLib = XApplication :: GetApplication ()->GetResourceLibrary ();
   XResource r (IDR_COLOR_CONV_PAGE, resLib);

#define tmpPage(IDR) \
   r.SetID (IDR); \
   resLib->LoadString (&tabText, r.GetID ()); \
   new XNoteBookPage (notebook, &r, BP_MAJOR | BP_STATUSTEXTON, BKA_LAST, tabText);
   
   tmpPage (IDR_BITMAP_IMPORT);
   tmpPage (IDR_BITMAP_EXPORT);
   tmpPage (IDR_GEM_EXPORT);
   tmpPage (IDR_GIF_IMPORT);
   tmpPage (IDR_GIF_EXPORT);
   tmpPage (IDR_GREYMAP_IMPORT);
   tmpPage (IDR_GREYMAP_EXPORT);
   tmpPage (IDR_IAX_IMPORT);
   tmpPage (IDR_IAX_EXPORT);
   tmpPage (IDR_ILBM_EXPORT);
   tmpPage (IDR_JPEG_EXPORT);
   tmpPage (IDR_KIPS_IMPORT);
   tmpPage (IDR_KIPS_EXPORT);
   tmpPage (IDR_PCX_IMPORT);
   tmpPage (IDR_PSEG_IMPORT);
   tmpPage (IDR_PSEG_EXPORT);
   tmpPage (IDR_SPRITE_IMPORT);
   tmpPage (IDR_TARGA_EXPORT);
   tmpPage (IDR_TIFF_IMPORT);
   tmpPage (IDR_TIFF_EXPORT);
   tmpPage (IDR_YUV12C_EXPORT);

#undef tmpPage
}

class abc: public XFrameWindow {
   XPushButton* b;
   public:
      abc (): XFrameWindow (IDR_FILTER_PARAMETERS_WARP4, "TEST", XFrameWindow :: defaultStyle) {
         b = new XPushButton (this, XRect (10, 10, 200, 100), 123, BU_TEXT|BU_DEFAULT, "HEY");
         SetClient (b);
         Activate ();
      }

   BOOL DoCommand (LONG cmd) {
      XBitmapFilterDialog* t = new  XBitmapFilterDialog (this);
      t->Start ();
     return TRUE;
    }
};

main(int argc, char *argv[], char *envp[])
{
   try {
      abc* f = new abc ();
      XApplication :: GetApplication ()->Start ();
   } /* endtry */
   catch (XException& e) {
         e.ShowError ();
   } /* endcatch */
}
