#ifndef __OOL_XDRAGITEM_H__
#define __OOL_XDRAGITEM_H__

/*===========================================================================*/
/* OOL ------------------- the Open Object Library ------------------- r 1.0 */
/*===========================================================================*/
/*                              class: XDragItem                             */
/*                       derived from: XObject                               */
/*                        last update: 12/96                                 */
/*                      programmed by: Stefan von Brauk (sbrauk@gwdg.de)     */
/*===========================================================================*/

#include "xstring.h"
#include "xdragevn.h"


#ifdef OOL_FOR_OS2_X86

   //mechanism information
   #define DRG_M_FILE    "DRM_OS2FILE"
   #define DRG_M_OBJECT  "DRM_OBJECT"

   //format information
   #define DRG_F_TEXT    "DRF_TEXT"

#endif


class _export_ XDragItem: public XObject
{
      friend class XDragEvent;
      friend class XContainerDragEvent;
      friend class XWindowDrag;
      friend class XDragTransfer;
   private:
      PDRAGITEM item;
      BOOL allocated;
      PDRAGTRANSFER trans;
   public:
      XDragItem() { allocated = FALSE; trans = NULL; }
      XDragItem( const XWindow * sourceWindow, const SHORT operation = DRG_COPY, const LONG id = 0, const char * type = DRG_M_OBJECT , const char * mechanism = DRG_F_TEXT);
      ~XDragItem();
      void Accept( const BOOL accept = TRUE );
      void EndConversation( const BOOL success = TRUE);
      OOL_WINDOWHANDLE GetSourceWindow(void) { return item->hwndItem; }
      USHORT GetControlOps();
      void GetContainerName( XString*);
      LONG GetID(void) {return item->ulItemID;}
      void GetMechanism( XString *);
      void GetName( XString * );
      void GetTargetName( XString *);
      void GetType( XString *);
      BOOL RenderPrepare( XWindow * target, USHORT operation, USHORT reply, char * mechanism, char * name, ULONG& suportedOps);
      void SetContainerName( const char *);
      void SetControlOps( USHORT );
      void SetMechanism( const char *);
      void SetName( const char *);
      void SetSupportedOps( USHORT ops);
      void SetTargetName( const char *);
      void SetType(char * type);
      BOOL VerifyItemType( const char * mechanism, const char * format = NULL);
      BOOL Render(XWindow * target, USHORT operation, USHORT reply, char * mechanism, char * name, ULONG& suportedOps);
};

#endif
